#!/usr/local/bin/wish -f

###########################################################################
#                                                                         #
# File   :	TkMount.tcl                                               #
# Project:	TkMount                                                   #
#                                                                         #
# Started:	22.09.97                                                  #
# Changed:	22.09.97                                                  #
# Author :      Gerhard Vogt                                              #
#                                                                         #
# Description:	The TkMount main routine, also containing (parts of) the  #
#               Configure, Option, Info, Preinfo Dialog, save and load    #
#               procedures and the automount function.                    #
#                                                                         #
# Copyright (C) 1997 by Gerhard Vogt                                      #
#                                                                         #
# This program is free software; you can redistribute it and/or modify    #
# it under the terms of the GNU General Public License as published by    #
# the Free Software Foundation; either version 2 of the License, or       #
# (at your option) any later version.                                     #
#                                                                         #
# This program is distributed in the hope that it will be useful,         #
# but WITHOUT ANY WARRANTY; without even the implied warranty of          #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           #
# GNU General Public License for more details.                            #
#                                                                         #
# You should have received a copy of the GNU General Public License       #
# along with this program; if not, write to the Free Software             #
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               #
# See the file "COPYING" in the base directory of this distribution       #
# for more.                                                               #
#                                                                         #
###########################################################################

###########################################################################
# Initialise variables                                                    #
###########################################################################

# set autopath [linsert $auto_path 0 /usr/lib/tcl7.6]
  set i 0
  set i3 0
  set buttonvar -1
  set deleted ""
  set mainvar 0
  set main -1
  set deletenr -1
  set mountListe ""
  set mainlist ""
  set j 0
  set optlist ""
  set menu 0
  set icon 0
  set pos 0
  set wxpos 0
  set wypos 0
  set onlybut 0
  set freq 0
  set sc 0
  set flistnr 0
  set oplistnr 0
  set devlistnr 0
  set piclistnr 0  
  set path ""
  set path2 ""
  set mountpoint ""
  set mounttries 0
  set labinfo hallo
  set index 0
  set autoloadtime 0
  set picture 0
  set srcpath [lindex $argv 0]/
  set autopath [linsert $auto_path 0 $srcpath\src]
  set outlook 0
  set senk 0
  set withnames 0
  set pre 0

proc ladeInListe {} {
  catch {unset mountListe}
  catch {unset Datei}
  set mountListe ""
  cd ~/
# set Datei [open "MountInfo.dat" r+]
  set datinfo [catch {set Datei [open "MountInfo.dat" r+]}]
  if {$datinfo == 0} {
    while {[gets $Datei Zeile] >= 0} {
      lappend mountListe $Zeile
      }
    close $Datei} else {
   set mountListe "{{-t iso9660} /dev/scd0 /cdrom {CD 1} CD-Rom}
{{} /dev/scd1 /cdrom2 {CD 2} CD-Rom}
{{ -a} /dev/fd0 /drive Disk Disk}
{{ -t vfat} /dev/sdb4 /zip Zip Zip-Drive}"
    }
  return $mountListe
  }

proc TraceProcN {VarName ElemName Operation} {
  global main mainlist
  scan $VarName "mainvar%d" main
  }

proc TraceProc {VarName ElemName Operation} {
  global deletenr
  scan $VarName "deletevar%d" deletenr
  }
  
proc TraceProcFlist {VarName ElemName Operation} {
  global flistnr
  scan $VarName "flistvar%d" flistnr
  }

proc TraceProcOplist {VarName ElemName Operation} {
  global oplistnr
  scan $VarName "oplistvar%d" oplistnr
  }

proc TraceProcDevlist {VarName ElemName Operation} {
  global devlistnr
  scan $VarName "devlistvar%d" devlistnr
  }
  
proc TraceProcPiclist {VarName ElemName Operation} {
  global piclistnr
  scan $VarName "picvar%d" piclistnr
  }  

###########################################################################
# The Configuration Dialog                                                #
###########################################################################

proc configureDialog {} {

  global i deleted buttonvar i3 flistnr deletenr mountpoint oplistnr piclistnr
  
  catch {unset mountListe}
  catch {unset deleted}
  catch {unset buttonvar}
  catch {unset elementD}
  catch {unset element}
  set i 0
  set i3 0
  set mountListe [ladeInListe]
   
  catch {destroy .cw}
  toplevel .cw -class Dialog
  wm title .cw Configuration

  frame .cw.left -width 15c -height 10c -relief ridge -borderwidth 4
  frame .cw.right -width 3c -height 3c
  pack .cw.left -side top -padx 1m -pady 1m
  pack .cw.right -side top -fill both

###########################################################################
# Saving Routine:                                                         #
###########################################################################

 set deleted ""

  button .cw.right.b -text "Done" -anchor n -command {
    set stop 0
# set deleted [split $deleted " "]
    cd ~/
    set Datei [open "MountInfo.dat" w+]
    for {set i2 0} {$i2 <= $i} {incr i2} {
      set stop 0
      foreach elementD $deleted {
        if {$i2 == $elementD} {
          set stop 1}
        }
      if {$stop == 0} { 
      set s1 "list \"\$command$i2\" \"\$device$i2\" \"\$mountpoint$i2\" \"\$name$i2\" \"\$picture$i2\""
      puts $Datei [eval "$s1"]}
      }
    close $Datei
    destroy .cw
    for {set h 0} {$h <= $i} {incr h} {
      unset "command$h"
      unset "device$h"
      unset "mountpoint$h"
      unset "name$h"
      }
    main
    }

###########################################################################
# Add a Newline                                                           #
###########################################################################

  button .cw.right.b2 -text "Add" -anchor n -command {
    incr i
    frame .cw.left.frame$i -width 15c
    entry .cw.left.frame$i.entry1$i -width 15 -relief sunken -bd 2 \
          -textvariable command$i
    button .cw.left.frame$i.oplist$i -text "..." -textvariable oplistvar$i \
          -command {
      after 100 {
      set s "\$command$oplistnr"
      gv_oplist [eval "list $s"]}
    }
    entry .cw.left.frame$i.entry2$i -width 15 -relief sunken -bd 2 \
          -textvariable device$i
    button .cw.left.frame$i.devlist$i -text "..." -textvariable devlistvar$i \
    -command {
      after 100 {
      gv_devlist}
    }
    entry .cw.left.frame$i.entry3$i -width 15 -relief sunken -bd 2 \
          -textvariable mountpoint$i
    button .cw.left.frame$i.flist$i -text "..." -textvariable flistvar$i \
    -command {
      after 100 {
        gv_filelist}
      }
    entry .cw.left.frame$i.entry4$i -width 10 -relief sunken -bd 2\
          -textvariable name$i
    label .cw.left.frame$i.label1$i -textvariable picture$i -width 10
    button .cw.left.frame$i.picture$i -text "..." -textvariable picvar$i\
           -command {
      after 100 {
      set s "\$picture$piclistnr"
      gv_piclist [eval "list $s"]}
      }

###########################################################################    
# Delete Entry routine:                                                   #
###########################################################################

    button .cw.left.frame$i.button$i -text Delete -textvariable deletevar$i -anchor w -command {      
      after 100 {
      if {$deletenr != 0} {
      destroy .cw.left.frame$deletenr
      lappend deleted $deletenr} else {
      .cw.left.frame0.entry10 delete 0 end
      .cw.left.frame0.entry20 delete 0 end
      .cw.left.frame0.entry30 delete 0 end
      .cw.left.frame0.entry40 delete 0 end
      .cw.left.frame0.entry10 insert 0 ""
      .cw.left.frame0.entry20 insert 0 ""
      .cw.left.frame0.entry30 insert 0 ""
      .cw.left.frame0.entry40 insert 0 ""      
        }}
      }
    trace variable deletevar$i r TraceProc
    trace variable flistvar$i3 r TraceProcFlist
    trace variable devlistvar$i3 r TraceProcDevlist
    trace variable oplistvar$i3 r TraceProcOplist    
    trace variable picvar$i3 r TraceProcPiclist
      
    pack .cw.left.frame$i.button$i .cw.left.frame$i.entry1$i .cw.left.frame$i.oplist$i .cw.left.frame$i.entry2$i .cw.left.frame$i.devlist$i .cw.left.frame$i.entry3$i .cw.left.frame$i.flist$i .cw.left.frame$i.entry4$i .cw.left.frame$i.label1$i .cw.left.frame$i.picture$i -in .cw.left.frame$i -side left

#    pack .cw.left.frame$i.button$i .cw.left.frame$i.entry1$i .cw.left.frame$i.oplist$i .cw.left.frame$i.entry2$i .cw.left.frame$i.devlist$i .cw.left.frame$i.entry3$i .cw.left.frame$i.flist$i .cw.left.frame$i.entry4$i -in .cw.left.frame$i -side left -fill x

    pack .cw.left.frame$i -in .cw.left -side top -fill x
    }

  button .cw.right.b3 -text "Cancel" -anchor n -command {
    destroy .cw
    for {set h 0} {$h <= $i} {incr h} {
      unset "command$h"
      unset "device$h"
      unset "mountpoint$h"
      unset "name$h"
      }
    main
    }
    
# raise .cw.right.b
# raise .cw.right.b2
# pack configure .cw.right.b2 .cw.right.b .cw.right.b3 -anchor n  
  pack .cw.right.b2 .cw.right.b .cw.right.b3 -in .cw.right -expand 1 -side left -fill x

###########################################################################
# Make Headline:                                                          #
###########################################################################

  frame .cw.left.headframe -width 15c
  frame .cw.left.headframe.f1 -width 1c
  frame .cw.left.headframe.f2 -width 1c
  frame .cw.left.headframe.f3 -width 1c
  frame .cw.left.headframe.f4 -width 1c
  frame .cw.left.headframe.f5 -width 1c
  frame .cw.left.headframe.f6 -width 1c
  label .cw.left.headframe.f1.label1 -text "mount +" -anchor w
  label .cw.left.headframe.f2.label2 -text "Options:" -anchor w
  label .cw.left.headframe.f3.label3 -text "Devicename:" -anchor w
  label .cw.left.headframe.f4.label4 -text "Mountpoint:" -anchor w
  label .cw.left.headframe.f5.label5 -text "Buttonname:" -anchor w
  label .cw.left.headframe.f6.label6 -text "Picture:" -anchor e
  pack .cw.left.headframe.f1.label1 -in .cw.left.headframe.f1 -side left
  pack .cw.left.headframe.f2.label2 -in .cw.left.headframe.f2 -side left    
  pack .cw.left.headframe.f3.label3 -in .cw.left.headframe.f3 -side left
  pack .cw.left.headframe.f4.label4 -in .cw.left.headframe.f4 -side left
  pack .cw.left.headframe.f5.label5 -in .cw.left.headframe.f5 -side left
  pack .cw.left.headframe.f6.label6 -in .cw.left.headframe.f6 -side right  
  pack .cw.left.headframe.f1 .cw.left.headframe.f2 .cw.left.headframe.f3 \
  .cw.left.headframe.f4 .cw.left.headframe.f5 -in .cw.left.headframe \
  -side left -fill none -expand 1
  pack .cw.left.headframe.f6 -in .cw.left.headframe -side right -fill none\
  -expand 1
  pack .cw.left.headframe -in .cw.left -side top -expand 1 -fill x

###########################################################################  
# Build Body (simular to Add):                                            #
###########################################################################

  foreach element $mountListe {
    frame .cw.left.frame$i -width 15c
    entry .cw.left.frame$i.entry1$i -width 15 -relief sunken -bd 2\
          -textvariable command$i
    .cw.left.frame$i.entry1$i insert insert [lindex $element 0]

    button .cw.left.frame$i.oplist$i -text "..." -textvariable oplistvar$i\
           -command {
      after 100 {
      set s "\$command$oplistnr"
      gv_oplist [eval "list $s"]}
    }
    
    entry .cw.left.frame$i.entry2$i -width 15 -relief sunken -bd 2 \
          -textvariable device$i
    .cw.left.frame$i.entry2$i insert insert [lindex $element 1]

    button .cw.left.frame$i.devlist$i -text "..." -textvariable devlistvar$i\
           -command {
      after 100 {
      gv_devlist}
      }
    entry .cw.left.frame$i.entry3$i -width 15 -relief sunken -bd 2\
          -textvariable mountpoint$i
    .cw.left.frame$i.entry3$i insert insert [lindex $element 2]

    button .cw.left.frame$i.flist$i -text "..." -textvariable flistvar$i\
           -command {
      after 100 {
      gv_filelist}
      }
    entry .cw.left.frame$i.entry4$i -width 10 -relief sunken -bd 2\
          -textvariable name$i
    .cw.left.frame$i.entry4$i insert insert [lindex $element 3]
    label .cw.left.frame$i.label1$i -textvariable picture$i -width 10
    button .cw.left.frame$i.picture$i -text "..." -textvariable picvar$i\
           -command {
      after 100 {
      set s "\$picture$piclistnr"
      gv_piclist [eval "list $s"]}
      }

###########################################################################    
# Delete Entry routine:                                                   #
###########################################################################

    button .cw.left.frame$i.button$i -text Delete -textvariable deletevar$i\
      -anchor w -command {
      after 100 {
      if {$deletenr != 0} {
      destroy .cw.left.frame$deletenr
      lappend deleted $deletenr} else {
      .cw.left.frame0.entry10 delete 0 end
      .cw.left.frame0.entry20 delete 0 end
      .cw.left.frame0.entry30 delete 0 end
      .cw.left.frame0.entry40 delete 0 end      
      .cw.left.frame0.entry10 insert 0 ""
      .cw.left.frame0.entry20 insert 0 ""
      .cw.left.frame0.entry30 insert 0 ""
      .cw.left.frame0.entry40 insert 0 ""
        }}
      }
    pack .cw.left.frame$i.button$i .cw.left.frame$i.entry1$i .cw.left.frame$i.oplist$i .cw.left.frame$i.entry2$i .cw.left.frame$i.devlist$i .cw.left.frame$i.entry3$i .cw.left.frame$i.flist$i .cw.left.frame$i.entry4$i .cw.left.frame$i.label1$i .cw.left.frame$i.picture$i -in .cw.left.frame$i -side left

    pack .cw.left.frame$i -in .cw.left -side top
    incr i
    }
    if {$i>0} {
      set i [expr $i - 1]}
  after 100 {
    set h1 0
    foreach element $mountListe {      
      set picture$h1 [lindex $element 4]
      incr h1}
    }

  after 100 {
    for {set i3 0} {$i3<=$i} {incr i3} {
      trace variable deletevar$i3 r TraceProc
      trace variable flistvar$i3 r TraceProcFlist
      trace variable devlistvar$i3 r TraceProcDevlist
      trace variable oplistvar$i3 r TraceProcOplist
      trace variable picvar$i3 r TraceProcPiclist
    }
  }
  
###########################################################################
# Set Window:                                                             #
###########################################################################

  wm withdraw .cw
  update idletasks
  set x [expr [winfo screenwidth .cw]/2 -[winfo reqwidth .cw]/2 - [winfo vrootx [winfo parent .cw]]]
  set y [expr [winfo screenheight .cw]/2 -[winfo reqheight .cw]/2 - [winfo vrooty [winfo parent .cw]]]
  wm geom .cw +$x+$y
  wm deiconify .cw
  grab set .cw
  }

###########################################################################
# Initialise Options                                                      #
###########################################################################

proc openOpt {} {
  global optlist sc freq autoloadtime outlook senk withnames
  cd ~/
  set datinfo [catch {set Datei [open "Options.dat" r+]}]
  if {$datinfo == 0} {
    while {[gets $Datei Zeile] >= 0} {
      set optlist $Zeile"
      set optlist [split $optlist " "]
      }
    close $Datei
    } else {
    set optlist "0 0 0 6 452 0 2 500 20 0 0 1 "}
  set sc [lindex $optlist 6]
  set freq [lindex $optlist 7]
  set autoloadtime [lindex $optlist 8]
  set outlook [lindex $optlist 9]
  set senk [lindex $optlist 10]
  set withnames [lindex $optlist 11]
  }

###########################################################################
# Save Options:                                                           #
###########################################################################

proc saveOpt {menu icon pos} {
global wxpos wypos onlybut sc freq autoloadtime outlook senk withnames
  set wxpos [winfo rootx .]
  set wypos [winfo rooty .]
  cd ~/
  set Datei [open "Options.dat" w+]
  puts $Datei "$menu $icon $pos $wxpos $wypos $onlybut $sc $freq $autoloadtime $outlook $senk $withnames "
  close $Datei
  }

proc setzeWert value {
  set freq [format %02x [.ow.top.right.scale get]]}

###########################################################################
# Option Dialog                                                           #
###########################################################################

proc optionDialog {} {

global optlist menu icon pos onlybut autoloadtime outlook sc withnames senk

# Set Window:

  catch {unset optlist}
  set optlist ""

  openOpt  
  catch {destroy .ow}
  toplevel .ow -class Dialog
  wm title .ow Options

  frame .ow.top
  frame .ow.top.left
  frame .ow.top.left.up -relief ridge -borderwidth 4
  frame .ow.top.left.down -relief ridge -borderwidth 4  
  frame .ow.top.right -relief ridge -borderwidth 4
  frame .ow.middle -relief ridge -borderwidth 4
  frame .ow.middle.right 
  frame .ow.middle.left
  frame .ow.bottom

  pack .ow.top .ow.middle .ow.bottom -in .ow -side top -fill both
  pack .ow.top.left .ow.top.right -in .ow.top -side left -fill both
  pack .ow.top.left.up .ow.top.left.down -in .ow.top.left -side top -fill both
  pack .ow.middle.left -in .ow.middle \
       -side left -fill both
  pack .ow.middle.right -in .ow.middle \
       -side right -fill both
  button .ow.bottom.done -text Done -command {
    saveOpt $menu $icon $pos
    destroy .ow
    main}
  pack .ow.bottom.done -in .ow.bottom -fill y

  checkbutton .ow.top.left.up.icon -text "Start iconified" -variable icon \
              -anchor w
  checkbutton .ow.top.left.up.pos -text "Remember position" -variable pos \
              -anchor w
  checkbutton .ow.top.left.up.menu -text "Hide menubar" -variable menu \
              -anchor w
  checkbutton .ow.top.left.up.onlybut -text "Only show buttons" \
              -variable onlybut -anchor w
  scale .ow.top.left.down.scale -label "Automountime (in sec):" \
              -from 0 -to 100 -length 6c -orient horizontal \
              -variable autoloadtime
  pack .ow.top.left.up.icon .ow.top.left.up.pos .ow.top.left.up.menu \
       .ow.top.left.up.onlybut -in .ow.top.left.up -side top -fill both
  pack .ow.top.left.down.scale -in .ow.top.left.down -side top -fill both

  scale .ow.top.right.scale -label "Control frequence:" -from 200 -to 5000 \
        -length 8c -orient horizontal -variable freq

  radiobutton .ow.top.right.no -text "No setting control" -variable sc \
              -value 0 -anchor w -command {
              if {$sc==2} {
                .ow.top.right.scale configure -state normal
                } else {
                .ow.top.right.scale configure -state disabled
                }}
  radiobutton .ow.top.right.start -text "Only start control" -variable sc \
              -value 1 -anchor w -command {
              if {$sc==2} {
                .ow.top.right.scale configure -state normal
                } else {
                .ow.top.right.scale configure -state disabled
                }}
  radiobutton .ow.top.right.perm -text "Permanent setting control" \
              -variable sc -value 2 -anchor w -command {
              if {$sc==2} {
                .ow.top.right.scale configure -state normal
                } else {
                .ow.top.right.scale configure -state disabled
                }}
  pack .ow.top.right.no .ow.top.right.start .ow.top.right.perm \
              -in .ow.top.right -side top -fill x
  
  pack .ow.top.right.scale -in .ow.top.right -side bottom -fill x

  radiobutton .ow.middle.left.classic -text "Classic Style" -variable outlook \
              -value 1 -command {
              if {$outlook == 0} {
                .ow.top.left.up.onlybut configure -state disabled
                .ow.middle.right.senk configure -state normal
                .ow.middle.right.hor configure -state normal
                .ow.middle.right.names configure -state normal
              } else {
                .ow.top.left.up.onlybut configure -state normal
                .ow.middle.right.senk configure -state disabled
                .ow.middle.right.hor configure -state disabled
                .ow.middle.right.names configure -state disabled                
                }
                }
  radiobutton .ow.middle.left.pictured -text "Pictured style" \
              -variable outlook -value 0 -command {
              if {$outlook == 0} {
                .ow.top.left.up.onlybut configure -state disabled
                .ow.middle.right.senk configure -state normal
                .ow.middle.right.hor configure -state normal
                .ow.middle.right.names configure -state normal                
              } else {
                .ow.top.left.up.onlybut configure -state normal
                .ow.middle.right.senk configure -state disabled
                .ow.middle.right.hor configure -state disabled
                .ow.middle.right.names configure -state disabled
                }
                }
  pack .ow.middle.left.classic .ow.middle.left.pictured -in .ow.middle.left \
              -fill both -side top
  radiobutton .ow.middle.right.senk -text "Dislplay horizontally" \
              -variable senk -value 1 -anchor w
  radiobutton .ow.middle.right.hor -text "Dislplay vertically" -variable senk \
              -value 0 -anchor w
  checkbutton .ow.middle.right.names -text "Display names" -variable withnames \
              -anchor w
  pack .ow.middle.right.names .ow.middle.right.senk .ow.middle.right.hor \
              -in .ow.middle.right -fill both

  set menu [lindex $optlist 0]
  set icon [lindex $optlist 1]
  set pos [lindex $optlist 2]
  set onlybut [lindex $optlist 5]
  set outlook [lindex $optlist 9]
  set senk [lindex $optlist 10]
  set withnames [lindex $optlist 11]

  if {$outlook == 0} {
    .ow.top.left.up.onlybut configure -state disabled
    .ow.middle.right.senk configure -state normal
    .ow.middle.right.hor configure -state normal
    .ow.middle.right.names configure -state normal
    } else {
    .ow.top.left.up.onlybut configure -state normal
    .ow.middle.right.senk configure -state disabled
    .ow.middle.right.hor configure -state disabled
    .ow.middle.right.names configure -state disabled
    }
  if {$sc==2} {
    .ow.top.right.scale configure -state normal
    } else {
    .ow.top.right.scale configure -state disabled
    }

  wm withdraw .ow
  update idletasks
  set x [expr [winfo screenwidth .ow]/2 -[winfo reqwidth .ow]/2 - [winfo vrootx [winfo parent .ow]]]
  set y [expr [winfo screenheight .ow]/2 -[winfo reqheight .ow]/2 - [winfo vrooty [winfo parent .ow]]]
  wm geom .ow +$x+$y
  wm deiconify .ow
  grab set .ow
  }

###########################################################################
# Info Dialog:                                                            #
###########################################################################

proc infoDialog {} {

global optlist menu icon pos onlybut

# Set Window:


  catch {destroy .iw}
  toplevel .iw -class Dialog
  wm title .iw Info

  frame .iw.top -relief groove -borderwidth 4
  frame .iw.bottom
  pack .iw.top .iw.bottom -in .iw -side top -padx 2m -pady 2m
  button .iw.bottom.license -text License -command {
    destroy .iw
    gv_licensebrowser License License
    }
  button .iw.bottom.warrenty -text Warranty -command {
    destroy .iw
    gv_licensebrowser Warranty Warranty
    }
  button .iw.bottom.done -text Done -command {
    destroy .iw
    }
  pack .iw.bottom.done .iw.bottom.license .iw.bottom.warrenty \
       -in .iw.bottom -fill y -side left

  label .iw.top.title -text "TK Mount" -font -adobe-courier-Bold-I-Normal--50-500-*-*-*-*-*-* -fg blue
  label .iw.top.t1 -text "Version 0.01b, Copyright (C) 1997 Gerhard Vogt"
  message .iw.top.msg1 -width 10c -justify center -text "Tk Mount comes with ABSOLUTELY NO WARRENTY; for details see Help/License."

  message .iw.top.msg2 -width 10c -justify center -text "This is free software, and you are welcome to redistribute it under certain conditions; see Help/License for details"
    pack .iw.top.title .iw.top.t1 .iw.top.msg1 .iw.top.msg2 -in .iw.top \
         -side top

  wm withdraw .iw
  update idletasks
  set x [expr [winfo screenwidth .iw]/2 -[winfo reqwidth .iw]/2 - [winfo vrootx [winfo parent .iw]]]
  set y [expr [winfo screenheight .iw]/2 -[winfo reqheight .iw]/2 - [winfo vrooty [winfo parent .iw]]]
  wm geom .iw +$x+$y
  wm deiconify .iw
  grab set .iw
  }

###########################################################################
# The following routine controls whether or not a disk is in the divice:  #
###########################################################################

proc timing {} {

global mainlist mountListe freq outlook

  set h 0
  foreach element $mountListe {
    set mounttext "[lindex $element 1] on [lindex $element 2]"
    set mountinfo [exec mount]
    if {[regexp "$mounttext" $mountinfo] == 1} {
    set mainlist [lreplace $mainlist $h $h "mounted"]
    if {$outlook==0} {
      .w.main.leftf.fr$h.mainbutton$h configure -image "[lindex $element 4] in"
      }
      } else {
    set mainlist [lreplace $mainlist $h $h "unmounted"]
    if {$outlook==0} {
      .w.main.leftf.fr$h.mainbutton$h configure -image "[lindex $element 4] out"
      }
    }    
    incr h
  }
  after 100 {
  set j3 0
  foreach element2 $mainlist {                
    set tvar$j3 [lindex $mainlist $j3]
    incr j3
    }}
  after $freq {timing}
  }

###########################################################################
# This routine tries to mount a device automatically                      #
###########################################################################

proc automount {mounttext} {

  global mainlist mountListe freq mounttries labinfo index autoloadtime outlook
  
  catch {eval exec mount [lindex $mounttext 0] [lindex $mounttext 1] [lindex $mounttext 2]}
  set mountinfo [exec mount]
  set mountresult "[lindex $mounttext 1] on [lindex $mounttext 2]"  
  if {[regexp "$mountresult" $mountinfo] == 1} {
    set mainlist [lreplace $mainlist $index $index "mounted"]
    set j3 0
    foreach element3 $mountListe {
      if {($outlook==0)&&($index==$j3)} {
        .w.main.leftf.fr$index.mainbutton$index configure \
               -image "[lindex $element3 4] in"}
        incr j3
        }    
    set minfo 0
    } else {set minfo 1}
  set labinfo "$mounttries $minfo mounted"
  after 100 {
    set j3 0
    foreach element2 $mainlist {                
      set tvar$j3 [lindex $mainlist $j3]
    incr j3
    }}
  incr mounttries

  if {($mounttries <= $autoloadtime) && ($minfo == 1)} {
    after 1000 {automount $mounttext}
    }
  }

###########################################################################
# Display title picture                                                   #
###########################################################################

proc preinfo {} {
  global pre srcpath
        
  catch {destroy .prew}
  
  toplevel .prew -class Dialog
  wm transient .prew .
  wm title .prew Info

  image create photo title \
      -file "$srcpath\pictures/title.gif"
	label .prew.title -image title
  
  label .prew.f -image title
  pack .prew.f -in .prew
  after 2000 {destroy .prew}
  set pre 1
  wm withdraw .prew
  update idletasks  
  set x [expr [winfo screenwidth .prew]/2 -[winfo reqwidth .prew]/2 - [winfo vrootx [winfo parent .prew]]]
  set y [expr [winfo screenheight .prew]/2 -[winfo reqheight .prew]/2 - [winfo vrooty [winfo parent .prew]]]
  wm geom .prew +$x+$y
  wm deiconify .prew
  }
    
###########################################################################
# Main routine:                                                           #
###########################################################################

proc main {} {

global i i3 buttonvar deleted mainvar main deletenr mountListe mainlist j menu pos icon optlist wxpos wypos onlybut sc mounttries labinfo autoloadtime outlook senk withnames pre srcpath

# Initialise mountListe:

catch {destroy .w.main}
catch {destroy .w.mbar}
catch {destroy .w}
catch {destroy .b}
catch {destroy .l}
catch {unset mountListe}
catch {unset element}
set mountListe [ladeInListe]

catch {unset optlist}
set optlist ""

# set menu 1

openOpt

set menu [lindex $optlist 0]
set icon [lindex $optlist 1]
set pos [lindex $optlist 2]
set wxpos [lindex $optlist 3]
set wypos [lindex $optlist 4]
set onlybut [lindex $optlist 5]
set outlook [lindex $optlist 9]
set senk [lindex $optlist 10]
set withnames [lindex $optlist 11]

wm title . "TK Mount 0.01b"
wm iconname . "TK Mount"
if {$icon == 1} {        
  wm iconify .}

if {$pos == 1} {
  wm geom . +$wxpos+$wypos}

frame .w -width 6c -height 5c -bg white

pack .w

frame .w.mbar -relief raised -bd 2
frame .w.ibar -relief raised -bd 2
frame .w.main -width 6c -height 2c -bg white
# frame .w.main1 -width 6c -height 2c -bg white
#pack .w.mbar .w.ibar .w.main1 .w.main -in .w -side top -fill x
pack .w.mbar .w.ibar .w.main -in .w -side top -fill x
# button .w.ibar.info -bitmap info
# pack .w.ibar.info -in .w.ibar -side left
  
bind .w <Leave> {
  catch {destroy .w.ibar}
  catch {destroy .w.pic1}
  catch {destroy .w.pic2}
  catch {destroy .w.pic3}
  catch {destroy .w.pic4}
  catch {destroy .w.pic5}
  catch {destroy .w.pic6}
  }
                
bind .w <Enter> {  
  catch {destroy .w.ibar}
  catch {destroy .w.pic1}
  catch {destroy .w.pic2}
  catch {destroy .w.pic3}
  catch {destroy .w.pic4}
  catch {destroy .w.pic5}
  catch {destroy .w.pic6}
  frame .w.ibar -relief raised -bd 2
  pack .w.mbar .w.ibar .w.main -in .w -side top -fill x


image create photo Pic3 \
      -file "$srcpath\pictures/option.gif"
	label .w.pic3 -image Pic3
image create photo Pic2 \
      -file "$srcpath\pictures/config.gif"
	label .w.pic2 -image Pic2
image create photo Pic4 \
      -file "$srcpath\pictures/Info.gif"
	label .w.pic4 -image Pic4
image create photo Pic5 \
      -file "$srcpath\pictures/help.gif"
	label .w.pic5 -image Pic5
image create photo Pic1 \
      -file "$srcpath\pictures/exit.gif"
	label .w.pic1 -image Pic1

  button .w.ibar.configure -image Pic2 -width 0.9c -height 0.9c \
         -command configureDialog -justify center -anchor center
  button .w.ibar.options -image Pic3 -width 0.9c -height 0.9c \
         -command optionDialog -justify center -anchor center
  button .w.ibar.exit -image Pic1 -width 0.9c -height 0.9c -command {
    saveOpt $menu $icon $pos        
    exit}
  pack .w.ibar.exit .w.ibar.options .w.ibar.configure -in .w.ibar \
       -side left -fill y -expand 1

  button .w.ibar.help -image Pic5 -width 0.9c -height 0.9c -command {
        catch {destroy .w.ibar}
        gv_helpbrowser}
  button .w.ibar.info -image Pic4 -width 0.9c -height 0.9c -command infoDialog
  pack .w.ibar.help .w.ibar.info -in .w.ibar -side right -fill y -expand 1  
 }

if {$outlook==1} {
  frame .w.main.rightf -width 3c
  frame .w.main.leftf
  } else {
    frame .w.main.leftf -bg white}
    
if {($onlybut == 0)&&($outlook==1)} {
  pack .w.main.leftf .w.main.rightf -in .w.main -fill x -side left -expand 1
  } else {
  pack .w.main.leftf -in .w.main -fill x -side left -expand 1}
  set j 0

# image create photo cabel1 \
#      -file "/dosc/TkMountBilder/cabel.gif"
#	label .w.cabel1 -image cabel1
#  label .w.main1.l1 -image cabel1 -borderwidth 0
#  label .w.main1.l2 -image cabel1 -borderwidth 0
#  label .w.main1.l3 -image cabel1 -borderwidth 0
#  label .w.main1.l4 -image cabel1 -borderwidth 0
#  pack .w.main1.l1 .w.main1.l2 .w.main1.l3 .w.main1.l4 -in .w.main1 -side left

if {$outlook==1} {
foreach element $mountListe {
        
# Mounting:

  button .w.main.leftf.mainbutton$j -textvar mainvar$j \
         -text [lindex $element 3]
  bind .w.main.leftf.mainbutton$j <Button-1> {
    set j2 0
    foreach element $mountListe {
      if {$j2 == $main} {
        if {$env(USER)=="root"} {
          if {[lindex $element 2] != ""} {
            catch {eval exec umount [lindex $element 2]} info} else {
            catch {eval exec umount [lindex $element 1]} info}
          } else {
          if {[lindex $element 2]!=""} {
            catch {eval exec umount [lindex $element 2]} info} else {
            catch {eval exec umount [lindex $element 1]} info}                
          }
        set mainlist [lreplace $mainlist $main $main "unmounted"]
        set j3 0
        foreach element2 $mainlist {                
          set tvar$j3 [lindex $mainlist $j3]
          incr j3
          }
        if {$info != ""} {
          if {$env(USER)=="root"} {                
            catch {eval exec mount [lindex $element 0] [lindex $element 1] [lindex $element 2]}
            } else {
            if {[lindex $element 2] != ""} {
              catch {eval exec mount [lindex $element 2]} info} else {
              catch {eval exec mount [lindex $element 1]} info}                
              }
          set mainlist [lreplace $mainlist $main $main "mounted"]
          set j3 0
          foreach element2 $mainlist {                
            set tvar$j3 [lindex $mainlist $j3]
            incr j3
            }
          }
        }
      incr j2
      }
  }
  
  lappend mainlist "unknown"
  frame .w.main.rightf.f$j -width 5c -height 1c -relief raised
  label .w.main.rightf.f$j.l$j -textvariable tvar$j
  set tvar$j "unkonwn"
  pack propagate .w.main.rightf.f$j 0
  pack .w.main.leftf.mainbutton$j -in .w.main.leftf -side top -fill both -expand 1
  pack .w.main.rightf.f$j.l$j -in .w.main.rightf.f$j -side top -fill both -expand 1
  pack .w.main.rightf.f$j -in .w.main.rightf -side top -fill both -expand 1
  bind .w.main.leftf.mainbutton$j <Control-Button-1> {
    set mounttries 0
    eval {set mounttext [lindex $mountListe $main]}
    set index $main
    automount $mounttext
    }
  incr j
  }
  } else {

image create photo "CD-Rom out" \
      -file "$srcpath\pictures/cdklein2.gif"
	label .w.cdout -image "CD-Rom out"
image create photo "CD-Rom in" \
      -file "$srcpath\pictures/cdkleinin2.gif"
	label .w.cdin -image "CD-Rom in"
image create photo "Zip-Drive out" \
      -file "$srcpath\pictures/zip2out.gif"
	label .w.zipout -image "Zip-Drive out"
image create photo "Zip-Drive in" \
      -file "$srcpath\pictures/zip2in.gif"
	label .w.zipin -image "Zip-Drive in"
image create photo "Disk in" \
      -file "$srcpath\pictures/diskin.gif"
	label .w.diskin -image "Disk in"
image create photo "Disk out" \
      -file "$srcpath\pictures/diskout.gif"
	label .w.diskout -image "Disk out"
image create photo "Harddisk in" \
      -file "$srcpath\pictures/hardon.gif"
	label .w.hardin -image "Harddisk in"
image create photo "Harddisk out" \
      -file "$srcpath\pictures/hardoff.gif"
	label .w.hardout -image "Harddisk out"
image create photo "Network in" \
      -file "$srcpath\pictures/compon.gif"
	label .w.netin -image "Network in"
image create photo "Network out" \
      -file "$srcpath\pictures/compoff.gif"
	label .w.netout -image "Network out"
	
foreach element $mountListe {

# Mounting:
  frame .w.main.leftf.fr$j -bg white
  set mounttext "[lindex $element 1] on [lindex $element 2]"
  set mountinfo [exec mount]
  if {$sc==1} {
    if {[regexp "$mounttext" $mountinfo] == 1} {
      button .w.main.leftf.fr$j.mainbutton$j -textvar mainvar$j \
             -text [lindex $element 3] -image "[lindex $element 4] in" \
             -borderwidth 0 -padx 0 -pady 0 -highlightthickness 0 -bg white \
             -highlightcolor white -activeforeground white \
             -activebackground white
      } else {
      button .w.main.leftf.fr$j.mainbutton$j -textvar mainvar$j \
             -text [lindex $element 3] -image "[lindex $element 4] out" \
             -borderwidth 0 -padx 0 -pady 0 -highlightthickness 0 -bg white \
             -highlightcolor white -activeforeground white \
             -activebackground white
      }
    } else {
      button .w.main.leftf.fr$j.mainbutton$j -textvar mainvar$j \
             -text [lindex $element 3] -image "[lindex $element 4] in" \
             -borderwidth 0 -padx 0 -pady 0 -highlightthickness 0 -bg white \
             -highlightcolor white -activeforeground white \
             -activebackground white
    }

  bind .w.main.leftf.fr$j.mainbutton$j <Button-1> {
    for {set l1 0} {$l1 <= [expr $j - 1]} {incr l1} {
      if {[.w.main.leftf.fr$l1.mainbutton$l1 cget -state] == "active"} {
        set main $l1}
      }
    set j2 0
    foreach element $mountListe {
      if {$j2 == $main} {
        if {$env(USER)=="root"} {
          if {[lindex $element 2] != ""} {
            catch {eval exec umount [lindex $element 2]} info} else {
            catch {eval exec umount [lindex $element 1]} info}
          } else {
          if {[lindex $element 2]!=""} {
            catch {eval exec umount [lindex $element 2]} info} else {
            catch {eval exec umount [lindex $element 1]} info}                
          }
        set mainlist [lreplace $mainlist $main $main "unmounted"]
        .w.main.leftf.fr$main.mainbutton$main configure -image "[lindex $element 4] out"
        set j3 0
        foreach element2 $mainlist {                
          set tvar$j3 [lindex $mainlist $j3]
          incr j3
          }
        if {$info != ""} {
          if {$env(USER)=="root"} {                
            catch {eval exec mount [lindex $element 0] [lindex $element 1] [lindex $element 2]}
            } else {
            if {[lindex $element 2] != ""} {
              catch {eval exec mount [lindex $element 2]} info} else {
              catch {eval exec mount [lindex $element 1]} info}
              }
          set mainlist [lreplace $mainlist $main $main "mounted"]
         .w.main.leftf.fr$main.mainbutton$main configure \
                -image "[lindex $element 4] in"
          set j3 0
          foreach element2 $mainlist {                
            set tvar$j3 [lindex $mainlist $j3]
            incr j3
            }
          }
        }
      incr j2
      }
  }
  
  lappend mainlist "unknown"
  set tvar$j "unkonwn"
  pack .w.main.leftf.fr$j -in .w.main.leftf -side left -fill both
  if {$senk == 0} {
    if {$withnames == 1} { 
      label .w.main.leftf.fr$j.lname$j -text [lindex $element 3] -bg white \
            -anchor e
      pack .w.main.leftf.fr$j.mainbutton$j \
           -in .w.main.leftf.fr$j -side left -fill both -expand 0
      pack .w.main.leftf.fr$j.lname$j \
           -in .w.main.leftf.fr$j -side right -fill both -expand 0
    } else {
    pack .w.main.leftf.fr$j.mainbutton$j \
         -in .w.main.leftf.fr$j -side left -fill both -expand 1
    }
    pack .w.main.leftf.fr$j -in .w.main.leftf -side top
    } else {
    if {$withnames == 1} {
      label .w.main.leftf.fr$j.lname$j -text [lindex $element 3] -bg white \
            -anchor s
      pack .w.main.leftf.fr$j.mainbutton$j \
           -in .w.main.leftf.fr$j -side top -fill both -expand 1            
      pack .w.main.leftf.fr$j.lname$j \
           -in .w.main.leftf.fr$j -side bottom -fill both -expand 1
    } else {
    pack .w.main.leftf.fr$j.mainbutton$j \
         -in .w.main.leftf.fr$j -side bottom -fill both -expand 1
    }
    pack .w.main.leftf.fr$j -in .w.main.leftf -side left
    }

  bind .w.main.leftf.fr$j.mainbutton$j <Control-Button-1> {
    for {set l1 0} {$l1 <= [expr $j - 1]} {incr l1} {
      if {[.w.main.leftf.fr$l1.mainbutton$l1 cget -state] == "active"} {
        set main $l1}
      }
    set mounttries 0
    eval {set mounttext [lindex $mountListe $main]}
    set index $main
    automount $mounttext
    }
  incr j
  }}

  after 100 {
    for {set i3 0} {$i3<=$j} {incr i3} {
    trace variable mainvar$i3 r TraceProcN}}

  after 100 {
    set j3 0
    foreach element2 $mainlist {                
      set tvar$j3 [lindex $mainlist $j3]
      incr j3
      }}

  if {$sc == 1} {
  set h 0
  foreach element $mountListe {
    set mounttext "[lindex $element 1] on [lindex $element 2]"
    set mountinfo [exec mount]
    if {[regexp "$mounttext" $mountinfo] == 1} {
    set mainlist [lreplace $mainlist $h $h "mounted"]
    if {$outlook==0} {
      .w.main.leftf.fr$h.mainbutton$h configure -image "[lindex $element 4] in"
      }
      } else {
    set mainlist [lreplace $mainlist $h $h "unmounted"]
    if {$outlook==0} {
     .w.main.leftf.fr$h.mainbutton$h configure -image "[lindex $element 4] out"
      }}
    incr h
  }

  after 100 {
  set j3 0
  foreach element2 $mainlist {                
    set tvar$j3 [lindex $mainlist $j3]
    incr j3
    }}        
  }
  if {$sc == 2} {     
  timing}

#label .l -textvar main -bg white
#pack .l

if {$menu == 0} {
  menubutton .w.mbar.file -text File -underline 0 -menu .w.mbar.file.menu
  menubutton .w.mbar.help -text Help -underline 0 -menu .w.mbar.help.menu
  pack .w.mbar.file -side left
  pack .w.mbar.help -side right

  menu .w.mbar.file.menu
  .w.mbar.file.menu add command -label Configure -command configureDialog
  .w.mbar.file.menu add command -label Options -command optionDialog
  .w.mbar.file.menu add separator
  .w.mbar.file.menu add command -label Exit -command {
    saveOpt $menu $icon $pos
    exit}

  menu .w.mbar.help.menu
  .w.mbar.help.menu add command -label Help -command {
        catch {destroy .w.ibar}
        gv_helpbrowser
        }        
  .w.mbar.help.menu add separator
  .w.mbar.help.menu add command -label License -command {gv_licensebrowser License License}
  .w.mbar.help.menu add command -label Warranty -command {gv_licensebrowser Warranty Warranty}
  .w.mbar.help.menu add separator
  .w.mbar.help.menu add command -label Info -command infoDialog
  if {$menu == 0} { 
  tk_menuBar .w.mbar .w.mbar.file .w.mbar.help}
  focus .w.mbar
  }
  if {$pre == 0} {
  preinfo}
}

foreach f [lsort [glob $srcpath\src/gv_*.tcl]] {
    #puts $f
    source $f
}

main